"use strict";

(function(window, undefined) {

  if(window.iw === undefined) window.iw = {};
  
  iw.defaultLogFile = "iwtest.log"
  
  iw.logs = new Vue({
    el: '#logs-app',
    data : {
      logFile            : iw.defaultLogFile,
      logData            : "",
      logFiles           : [],
      autorefresh        : false,
      refreshInterval    : 2500,
      scheduledServiceId : -1,
      product            : {},
      config             : {}
    },
    methods: {
      getLogData : function () {
        iw.invoke("iw.test.logging:getLogContent", {"log-file": iw.logs.logFile}, function(data) {
          iw.log("get log content called", 3);
          if(typeof(data) === 'string') {
          

            let lines = data.split("\n");
            iw.log("Nr of log lines: " + lines.length, 3);
            lines.reverse();
            //We're getting a new line at the beginning of joined array, so remove
            iw.logs.logData = lines.join("\n").substring(1);
            
          } else {
            iw.log("Get log content didn't return a string", 3)
            iw.log(data);
          }
          
        })
      },
      getInfo : function() {
        iw.invoke("iw.test.admin:info", {}, function(data) {
          iw.logs.product = data.product;   
        });
      },
      
      getConfig : function() {
        iw.invoke("iw.test.config:get", {}, function(data) {
          iw.logs.config = data;          
        });        
      },      
            
      getLogFiles : function () {
        iw.invoke("iw.test.logging:getLogFiles", {}, function(data) {iw.logs.logFiles = data["log-files"]});
      },
      
      toggleAutoRefresh : function (event) {

        //mouse event
        iw.log(event, 4);
        
        if(event.target.checked) {
          iw.logs.getLogData(iw.logs.logFile);
          
          iw.logs.scheduledServiceId = window.setInterval(function(){iw.logs.getLogData(iw.logs.logFile)}, iw.logs.refreshInterval);
          iw.log("Started autorefresh. Id: " +iw.logs.scheduledServiceId, 3);
        } else {
          window.clearInterval(iw.logs.scheduledServiceId);
          iw.log("Canceled autorefresh", 3);
        }
      }
      
      
      
    },
    watch: {
      logFile : function() {
        iw.logs.getLogData();
      }
    }

  })

  iw.logs.getLogData();
  iw.logs.getLogFiles();
  iw.logs.getInfo();
  iw.logs.getConfig();
})(this, undefined);